Index: squid/src/Plaxton.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/Plaxton.c,v
retrieving revision 1.1.2.1
retrieving revision 1.1.2.2
diff -u -r1.1.2.1 -r1.1.2.2
--- squid/src/Plaxton.c	20 Nov 2001 06:59:14 -0000	1.1.2.1
+++ squid/src/Plaxton.c	21 May 2002 02:46:42 -0000	1.1.2.2
@@ -1,7 +1,7 @@
 /*
- * $Date: 2001/11/20 06:59:14 $ $Id: Plaxton.c,v 1.1.2.1 2001/11/20 06:59:14 jkay Exp $
+ * $Date: 2002/05/21 02:46:42 $ $Id: Plaxton.c,v 1.1.2.2 2002/05/21 02:46:42 jkay Exp $
  *
- * DEBUG: section 56    Greg Plaxton's per-object hierarchy.
+ * DEBUG: section 91    Greg Plaxton's per-object hierarchy.
  * AUTHOR: Mike Dahlin, UT Austin, 1998
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -72,15 +72,15 @@
 #include "squid.h"
 
 
-#define HCPLAX_DEBUG 56
+#define HCPLAX_DEBUG 91
 
 /*
- * Array [BITS_PER_BYTE * sizeof(NodeKeyKey) + 1]  of List_Links.
+ * Array [BITS_PER_BYTE * sizeof(HintCacheNodeKeyKey) + 1]  of dlink_nodes
  */
 #define BITS_PER_BYTE 8
-#define BITS_PER_KEY (8 * sizeof(GenericKey))
+#define BITS_PER_KEY (8 * sizeof(HintCacheKey))
 
-static GenericKey myNodeKey;
+static HintCacheKey myNodeKey;
 
 static int initialized = 0;
 
@@ -88,9 +88,9 @@
  * For keeping track of children
  */
 static int nChildLists = -9999;
-static List_Links *childrenListA;
-static int *childrenCountA = NULL;    /* Entry i is the number of children
-				       * that match in i bits.  */
+static dlink_list *childrenListA;
+static int *childrenCountA = NULL;	/* Entry i is the number of children
+					 * that match in i bits.  */
 static int childrenCountTot = 0;
 
 /*
@@ -116,7 +116,7 @@
  * by their distance from me with the closest node always
  * at the head of its list.
  */
-static List_Links *parentListA = NULL;
+static dlink_list *parentListA = NULL;
 /*
  * Special case of parent finding when I match in as many bits
  * as anyone. In case of a tie for root, 
@@ -135,32 +135,32 @@
  * are sorted by the integer value of the key with the
  * largest value at the head of the list.
  */
-static List_Links *highestMatchA = NULL;
- 
+static dlink_list *highestMatchA = NULL;
+
 static int normalParentIndex(int bucket);
-static int fullMatchIndex(GenericKey k);
+static int fullMatchIndex(HintCacheKey k);
 static int firstLevelBucketForMatch(int matchBits);
 static int highestMatchIndex(int matchBits);
-static void childAdd _PARAMS((NodeKey *key));
-static NodeKey *childFind _PARAMS((NodeKey *key));
-static void freeList(List_Links *list);
+static void childAdd _PARAMS((HintCacheNodeKey * key));
+static HintCacheNodeKey *childFind _PARAMS((HintCacheNodeKey * key));
+static void freeList(dlink_list * list);
 static void addNodeParentList(struct sockaddr_in *addNode);
 static void removeNodeParentList(struct sockaddr_in *goneNode);
 static void changeDistanceParentList(struct sockaddr_in *changeDistNode);
-static int parentListIndex(NodeKey *n);
+static int parentListIndex(HintCacheNodeKey * n);
 static void addNodeHighestMatch(struct sockaddr_in *addNode);
-static void matchInsert(List_Links *l, struct sockaddr_in *a);
+static void matchInsert(dlink_list *l, struct sockaddr_in *a);
 static void removeNodeHighestMatch(struct sockaddr_in *goneNode);
-static void matchRemove(List_Links *l, struct sockaddr_in *a);
-static int scanForParentMatch(int maxTry, int minTry, const URLKey *key, 
-		   int *parentIndexRet, int *amIRootRet);
-static GenericKey makeMatchKey(const URLKey *key, int matchBits, 
-			       int permuteVal);
+static void matchRemove(dlink_list *l, struct sockaddr_in *a);
+static int scanForParentMatch(int maxTry, int minTry, const URLKey * key,
+    int *parentIndexRet, int *amIRootRet);
+static HintCacheKey makeMatchKey(const URLKey * key, int matchBits,
+    int permuteVal);
 
 #ifdef DOTEST
 static void selfTestChildren();
-static int selfTestFindAddr(int addr, struct sockaddr_in *childrenA, 
-			    int childCount);
+static int selfTestFindAddr(int addr, struct sockaddr_in *childrenA,
+    int childCount);
 static void selfTestParents();
 static void testParentsBinaryTree(void);
 static void testParentsMultiRootCase(void);
@@ -188,63 +188,56 @@
  *
  *-------------------------------------------------4.15.1998-----------
  */
-void plaxtonInit(int bitsPerLevel_)
+void
+plaxtonInit(int bitsPerLevel_)
 {
-  int ii;
-  int nParentBuckets;
-  struct sockaddr_in *me = &Config.Sockaddr.http->s;
-  NodeKey *key;
-
-  assert(nChildLists < 0); /* We shouldn't be initialized yet */
-
-  assert(!initialized);
-  initialized = 1;
-
-  myNodeKey = NodeKK_Key(me);
-  /*
-   * List i contains all children that match me in i bits.
-   * Legal values for i are [0, BITS_PER_KEY]
-   */
-  nChildLists = BITS_PER_KEY + 1;
-  assert(childrenListA == NULL);
-  childrenListA = xmalloc(nChildLists * sizeof(List_Links));
-  assert(childrenListA);
-  childrenCountA = xmalloc(nChildLists * sizeof(int));
-  for(ii = 0; ii < nChildLists; ii++){
-    List_Init(&childrenListA[ii]);
-    childrenCountA[ii] = 0;
-  }
-  childrenCountTot = 0;
-  
-  /*
-   * Parents
-   */
-  bitsPerLevel = bitsPerLevel_;
-  nParentLevels = (BITS_PER_KEY) / bitsPerLevel;
-  if((BITS_PER_KEY) % bitsPerLevel != 0){
-    nParentLevels++;
-  }
-  Plaxton_bucketsPerLevel = 1;
-  for(ii = 0; ii < bitsPerLevel; ii++){
-    Plaxton_bucketsPerLevel *= 2;
-  }
-  nParentBuckets = Plaxton_bucketsPerLevel * nParentLevels;
-  maxParentBucket = nParentBuckets - 1;
-  assert(parentListA == NULL);
-  parentListA = (List_Links *)xmalloc(nParentBuckets * sizeof(List_Links));
-  assert(parentListA);
-  for(ii = 0; ii < nParentBuckets; ii++){
-    List_Init(&parentListA[ii]);
-  }
-  assert(highestMatchA == NULL);
-  highestMatchA = (List_Links *)xmalloc(BITS_PER_KEY * sizeof(List_Links));
-  assert(highestMatchA);
-  for(ii = 0; ii < BITS_PER_KEY; ii++){
-    List_Init(&highestMatchA[ii]);
-    key = (NodeKey *)xmalloc(sizeof(NodeKey));
-    NodeKey_Init(key, me);
-    List_Insert((List_Links *)key, LIST_ATFRONT(&highestMatchA[ii]));
-  }
+    int ii;
+    int nParentBuckets;
+    struct sockaddr_in *me = &Config.Sockaddr.http->s;
+    HintCacheNodeKey *key;
+
+    assert(nChildLists < 0);	/* We shouldn't be initialized yet */
+
+    assert(!initialized);
+    initialized = 1;
+
+    myNodeKey = NodeKK_Key(me);
+    /*
+     * List i contains all children that match me in i bits.
+     * Legal values for i are [0, BITS_PER_KEY]
+     */
+    nChildLists = BITS_PER_KEY + 1;
+    assert(childrenListA == NULL);
+    childrenListA = (dlink_list *) xcalloc(nChildLists, sizeof(dlink_list));
+    assert(childrenListA);
+    childrenCountA = (int *) xcalloc(nChildLists, sizeof(int));
+    childrenCountTot = 0;
+
+    /*
+     * Parents
+     */
+    bitsPerLevel = bitsPerLevel_;
+    nParentLevels = (BITS_PER_KEY) / bitsPerLevel;
+    if ((BITS_PER_KEY) % bitsPerLevel != 0) {
+	nParentLevels++;
+    }
+    Plaxton_bucketsPerLevel = 1;
+    for (ii = 0; ii < bitsPerLevel; ii++) {
+	Plaxton_bucketsPerLevel *= 2;
+    }
+    nParentBuckets = Plaxton_bucketsPerLevel * nParentLevels;
+    maxParentBucket = nParentBuckets - 1;
+    assert(parentListA == NULL);
+    parentListA = (dlink_list *) xcalloc(nParentBuckets, sizeof(dlink_list));
+    assert(parentListA);
+    assert(highestMatchA == NULL);
+    highestMatchA = (dlink_list *) xcalloc(BITS_PER_KEY, sizeof(dlink_list));
+    assert(highestMatchA);
+    for (ii = 0; ii < BITS_PER_KEY; ii++) {
+	key = (HintCacheNodeKey *) xmalloc(sizeof(HintCacheNodeKey));
+	hintCacheNodeKeyInit(key, &Config.Sockaddr.http->s);
+	dlinkAdd(key, &key->links, &highestMatchA[ii]);
+    }
 }
 
 /*
@@ -265,40 +258,41 @@
  *
  *---------------------------------------------------4.16.1998------
  */
-void plaxtonDestroy(void)
+void
+plaxtonDestroy(void)
 {
-  int ii;
+    int ii;
 
-  assert(initialized);
-  initialized = 0;
+    assert(initialized);
+    initialized = 0;
 
-  assert(nChildLists > 0); /* Are we initialized? */
-  for(ii = 0; ii < nChildLists; ii++){
-    freeList(&childrenListA[ii]);
-  }
-  xfree(childrenListA);
-  childrenListA = NULL;
-  xfree(childrenCountA);
-  childrenCountA = NULL;
-  childrenCountTot = -999999;
-  nChildLists = -88888;
-
-  /*
-   * Parents
-   */
-  for(ii = 0; ii < nParentLevels * Plaxton_bucketsPerLevel; ii++){
-    freeList(&parentListA[ii]);
-  }
-  xfree(parentListA);
-  parentListA = NULL;
-  nParentLevels = -8888;
-  bitsPerLevel = -8888;
-  Plaxton_bucketsPerLevel = -8888;
-  for(ii = 0; ii < BITS_PER_KEY; ii++){
-    freeList(&highestMatchA[ii]);
-  }
-  xfree(highestMatchA);
-  highestMatchA = NULL;
+    assert(nChildLists > 0);	/* Are we initialized? */
+    for (ii = 0; ii < nChildLists; ii++) {
+	freeList(&childrenListA[ii]);
+    }
+    xfree(childrenListA);
+    childrenListA = NULL;
+    xfree(childrenCountA);
+    childrenCountA = NULL;
+    childrenCountTot = -999999;
+    nChildLists = -88888;
+
+    /*
+     * Parents
+     */
+    for (ii = 0; ii < nParentLevels * Plaxton_bucketsPerLevel; ii++) {
+	freeList(&parentListA[ii]);
+    }
+    xfree(parentListA);
+    parentListA = NULL;
+    nParentLevels = -8888;
+    bitsPerLevel = -8888;
+    Plaxton_bucketsPerLevel = -8888;
+    for (ii = 0; ii < BITS_PER_KEY; ii++) {
+	freeList(&highestMatchA[ii]);
+    }
+    xfree(highestMatchA);
+    highestMatchA = NULL;
 }
 
 
@@ -307,7 +301,7 @@
  *
  * freeList --
  *
- *          Free all elements on a list of NodeKeys
+ *          Free all elements on a list of HintCacheNodeKeys
  *
  * Arguments:
  *      type1 arg1 -- description.
@@ -321,15 +315,17 @@
  *----------------------------------------------------4.16.1998--------
  */
 static void
-freeList(List_Links *list)
+freeList(dlink_list *list)
 {
-  NodeKey *k;
-  assert(list);
-  while(!List_IsEmpty(list)){
-    k = (NodeKey *)List_First(list);
-    List_Remove((List_Links *)k);
-    xfree(k);
-  }
+    dlink_node *node;
+    HintCacheNodeKey *k;
+
+    assert(list);
+    for (node = list->head ; node; node = node->next) {
+	k = node->data;
+	dlinkDelete(node, list);
+	xfree(k);
+    }
 }
 
 /*
@@ -352,20 +348,20 @@
  *
  *----------------------------------------------------4.9.1998---------
  */
-void 
-plaxtonAddChild (struct sockaddr_in *child)
+void
+plaxtonAddChild(struct sockaddr_in *child)
 {
-  NodeKey *key;
-  
-  assert(initialized);
-  assert(nChildLists > 0); /* Are we initialized? */
-  key = (NodeKey *)xmalloc(sizeof(NodeKey));
-  NodeKey_Init(key, child);
-  if(childFind(key)){
-    xfree(key);
-    return;
-  }
-  childAdd(key);
+    HintCacheNodeKey *key;
+
+    assert(initialized);
+    assert(nChildLists > 0);	/* Are we initialized? */
+    key = (HintCacheNodeKey *) xmalloc(sizeof(HintCacheNodeKey));
+    hintCacheNodeKeyInit(key, child);
+    if (childFind(key)) {
+	xfree(key);
+	return;
+    }
+    childAdd(key);
 }
 
 /*
@@ -386,27 +382,28 @@
  *
  *------------------------------------------------------4.9.1998-----
  */
-void 
+void
 plaxtonRemoveChild(struct sockaddr_in *child)
 {
-  NodeKey key, *found;
-  int match;
+    HintCacheNodeKey key, *found;
+    int match;
 
-  assert(initialized);
-  assert(nChildLists > 0); /* Are we initialized? */
-  NodeKey_Init(&key, child);
-  found = childFind(&key);
-  if(found){
-    List_Remove((List_Links*)found);
-    xfree(found);
-    match = plaxtonMatchBits(key.key, myNodeKey);
-    childrenCountA[match]--;
-    childrenCountTot--;
-    assert(childrenCountA[match] >= 0);
-    assert(childrenCountTot >= 0);
+    assert(initialized);
+    assert(nChildLists > 0);	/* Are we initialized? */
+    hintCacheNodeKeyInit(&key, child);
+    found = childFind(&key);
+    if (found) {
+	dlinkDelete(&found->links, 
+	List_Remove((dlink_node *) found);
+	xfree(found);
+	match = plaxtonMatchBits(key.key, myNodeKey);
+	childrenCountA[match]--;
+	childrenCountTot--;
+	assert(childrenCountA[match] >= 0);
+	assert(childrenCountTot >= 0);
+	return;
+    }
     return;
-  }
-  return;
 }
 
 
@@ -432,16 +429,16 @@
 int
 plaxtonCheckIfChild(struct sockaddr_in *child)
 {
-  NodeKey key, *found;
-  
-  assert(initialized);
-  assert(nChildLists > 0); /* Are we initialized? */
-  NodeKey_Init(&key, child);
-  found = childFind(&key);
-  if(found != NULL){
-    return 1;
-  }
-  return 0; 
+    HintCacheNodeKey key, *found;
+
+    assert(initialized);
+    assert(nChildLists > 0);	/* Are we initialized? */
+    hintCacheNodeKeyInit(&key, child);
+    found = childFind(&key);
+    if (found != NULL) {
+	return 1;
+    }
+    return 0;
 }
 
 
@@ -482,44 +479,43 @@
  *
  *---------------------------------------------------5.1.1998------
  */
-int 
-plaxtonChildQIndex (URLKey *key, int iAmRoot, int *amILeaf)
+int
+plaxtonChildQIndex(URLKey * key, int iAmRoot, int *amILeaf)
 {
-  int match;
-  int leafCheck;
+    int match;
+    int leafCheck;
 
-  assert(initialized);
-  assert(nChildLists > 0); /* Are we initialized? */
+    assert(initialized);
+    assert(nChildLists > 0);	/* Are we initialized? */
 
 
-  if(iAmRoot){
-    if(/*childrenCountTot > 0*/ 1){ /* XXX */
-      *amILeaf = 0;
-      return nChildLists - 1;
-    }
-    else{
-      *amILeaf = 1;
-      return -999;
-    }
-  }
-  
-  match = plaxtonMatchBits(key->key, myNodeKey);
-  /*
-   * Check to see if I am a leaf for this object by looking
-   * at all childlists for children that match me in fewer bits 
-   * than this object. If all such lists are empty, than I am 
-   * a leaf. This is less inefficient than it seems. The expected
-   * number of queues I have to check is less than (1 + .5 + .25 + ...)
-   * (since I match in 0 bits half the time, ... )
-   */
-  *amILeaf = 1;
-  for(leafCheck = match - 1; leafCheck >= 0; leafCheck--){
-    if(!List_IsEmpty(&childrenListA[leafCheck])){
-      *amILeaf = 0;
-      break;
+    if (iAmRoot) {
+	if ( /*childrenCountTot > 0 */ 1) {	/* XXX */
+	    *amILeaf = 0;
+	    return nChildLists - 1;
+	} else {
+	    *amILeaf = 1;
+	    return -999;
+	}
+    }
+
+    match = plaxtonMatchBits(key->key, myNodeKey);
+    /*
+     * Check to see if I am a leaf for this object by looking
+     * at all childlists for children that match me in fewer bits 
+     * than this object. If all such lists are empty, than I am 
+     * a leaf. This is less inefficient than it seems. The expected
+     * number of queues I have to check is less than (1 + .5 + .25 + ...)
+     * (since I match in 0 bits half the time, ... )
+     */
+    *amILeaf = 1;
+    for (leafCheck = match - 1; leafCheck >= 0; leafCheck--) {
+	if (!List_IsEmpty(&childrenListA[leafCheck])) {
+	    *amILeaf = 0;
+	    break;
+	}
     }
-  }
-  return match;
+    return match;
 }
 
 /*
@@ -541,11 +537,12 @@
  *
  *-------------------------------------------------------4.10.1998---
  */
-int plaxtonNChildrenQs (void)
+int
+plaxtonNChildrenQs(void)
 {
-  assert(initialized);
-  assert(nChildLists > 0); /* Are we initialized? */
-  return nChildLists;
+    assert(initialized);
+    assert(nChildLists > 0);	/* Are we initialized? */
+    return nChildLists;
 }
 
 
@@ -580,39 +577,39 @@
  *
  *----------------------------------------------------4.10.1998-------
  */
-int 
-plaxtonGetChildAddrs (int qIndex, struct sockaddr_in **retAddrAP)
+int
+plaxtonGetChildAddrs(int qIndex, struct sockaddr_in **retAddrAP)
 {
-  int count;
-  int imatch;
-  NodeKey *current;
-  int check;
-
-  assert(initialized);
-  for(imatch = 0, count = 0; 
-      imatch <= qIndex; 
-      imatch++){
-    count += childrenCountA[imatch];
-  }
-  if(!count){
-    *retAddrAP = NULL;
-    return 0;
-  }
-  *retAddrAP=(struct sockaddr_in *)xmalloc(count * sizeof(struct sockaddr_in));
-  for(imatch = 0, count = 0; 
-      imatch <= qIndex; 
-      imatch++){
-    check = 0;
-    LIST_FORALL2(&childrenListA[imatch], NodeKey *, current){
-      check++;
-      (*retAddrAP)[count] = NodeKey_GetAddr(current);
-      count++;
-      debug(HCPLAX_DEBUG, 2, "plaxtonGetChildAddrs: sending msg to child %s\n",
-	    inet_ntoa((*retAddrAP)[count].sin_addr));
-    }
-    assert(check == childrenCountA[imatch]);
-  }
-  return count;
+    dlink_node *node;
+    int count;
+    int imatch;
+    HintCacheNodeKey *current;
+    int check;
+
+    assert(initialized);
+    for (imatch = 0, count = 0; imatch <= qIndex; imatch++) {
+	count += childrenCountA[imatch];
+    }
+    if (!count) {
+	*retAddrAP = NULL;
+	return 0;
+    }
+    *retAddrAP =
+	(struct sockaddr_in *) xmalloc(count * sizeof(struct sockaddr_in));
+    for (imatch = 0, count = 0; imatch <= qIndex; imatch++) {
+	check = 0;
+	for (node = childrenListA[imatch].head; node; node = node->next) {
+	    current = node->data;
+	    check++;
+	    (*retAddrAP)[count] = hintCacheNodeKeyGetAddr(current);
+	    count++;
+	    debug(HCPLAX_DEBUG, 2)
+		("plaxtonGetChildAddrs: sending msg to child %s\n",
+		inet_ntoa((*retAddrAP)[count].sin_addr));
+	}
+	assert(check == childrenCountA[imatch]);
+    }
+    return count;
 }
 
 
@@ -642,16 +639,16 @@
  *
  *----------------------------------------------------4.15.1998-------
  */
-int 
-plaxtonNParentQs (void)
+int
+plaxtonNParentQs(void)
 {
-  int normalParentCount, rootCaseCount;
-  
-  assert(initialized);
-  assert(parentListA != NULL);
-  normalParentCount = nParentLevels * Plaxton_bucketsPerLevel;
-  rootCaseCount = BITS_PER_KEY;
-  return normalParentCount + rootCaseCount;
+    int normalParentCount, rootCaseCount;
+
+    assert(initialized);
+    assert(parentListA != NULL);
+    normalParentCount = nParentLevels * Plaxton_bucketsPerLevel;
+    rootCaseCount = BITS_PER_KEY;
+    return normalParentCount + rootCaseCount;
 }
 
 
@@ -703,57 +700,56 @@
  *----------------------------------------------------4.19.1998---------
  */
 int
-plaxtonParentQIndex(URLKey *key, int *amIRoot)
+plaxtonParentQIndex(URLKey * key, int *amIRoot)
 {
-  int match;
-  int nextLevelMatch;
-  int found, pindex;
-
-  assert(initialized);
-  /* XXX */
-  match = plaxtonMatchBits(key->key, myNodeKey);
-  if(match == nParentLevels * bitsPerLevel){
+    int match;
+    int nextLevelMatch;
+    int found, pindex;
+
+    assert(initialized);
+    /* XXX */
+    match = plaxtonMatchBits(key->key, myNodeKey);
+    if (match == nParentLevels * bitsPerLevel) {
+	/*
+	 * Match all bits. I am root!
+	 */
+	*amIRoot = 1;
+	return -9999999;
+    }
+
+    /* 
+     * Try for full or partial match at next level.
+     */
+    nextLevelMatch = ((match + bitsPerLevel) / bitsPerLevel) * bitsPerLevel;
+    found = scanForParentMatch(nextLevelMatch, match + 1, key,
+	&pindex, amIRoot);
+    if (found) {
+	assert(!*amIRoot);
+	return normalParentIndex(pindex);
+    }
+
+
     /*
-     * Match all bits. I am root!
+     * I match in match bits, and didn't find anyone that matches
+     * in more. But, there may be other nodes that match the object 
+     * in the same number of bits (but differ from me in some higher bit). 
+     * We all need to agree on whom among us is the root. We need
+     * to do so in a way that avoids loops (and hopefully which
+     * gets everyone to agree on the same root.) Solution: if
+     * an object matches me in k bits and I know of no node
+     * that matches the object in more than k bits, choose as
+     * the root for that object, the node that matches the
+     * object (and me) in k bits and which has the highest
+     * known HintCacheNodeKey.
      */
-    *amIRoot = 1;
-    return -9999999;
-  }
-
-  /* 
-   * Try for full or partial match at next level.
-   */
-  nextLevelMatch = ((match + bitsPerLevel) / bitsPerLevel) * bitsPerLevel;
-  found = scanForParentMatch(nextLevelMatch, match+1, key, 
-			     &pindex, amIRoot);
-  if(found){
-    assert(!*amIRoot);
-    return normalParentIndex(pindex);
-  }
- 
-
-  /*
-   * I match in match bits, and didn't find anyone that matches
-   * in more. But, there may be other nodes that match the object 
-   * in the same number of bits (but differ from me in some higher bit). 
-   * We all need to agree on whom among us is the root. We need
-   * to do so in a way that avoids loops (and hopefully which
-   * gets everyone to agree on the same root.) Solution: if
-   * an object matches me in k bits and I know of no node
-   * that matches the object in more than k bits, choose as
-   * the root for that object, the node that matches the
-   * object (and me) in k bits and which has the highest
-   * known NodeKey.
-   */
-  assert(!List_IsEmpty(&highestMatchA[match]));
-  if(((NodeKey *)List_First(&highestMatchA[match]))->key == myNodeKey){
-    *amIRoot = 1;
-    return -999999;
-  }
-  else{
-    *amIRoot = 0;
-    return highestMatchIndex(match);
-  }
+    assert(!List_IsEmpty(&highestMatchA[match]));
+    if (((HintCacheNodeKey *) List_First(&highestMatchA[match]))->key == myNodeKey) {
+	*amIRoot = 1;
+	return -999999;
+    } else {
+	*amIRoot = 0;
+	return highestMatchIndex(match);
+    }
 }
 
 
@@ -796,62 +792,62 @@
  *------------------------------------------------------------------
  */
 static int
-scanForParentMatch(int maxTry, int minTry, const URLKey *key, 
-		   int *parentIndexRet, int *amIRootRet)
+scanForParentMatch(int maxTry, int minTry, const URLKey * key,
+    int *parentIndexRet, int *amIRootRet)
 {
-  GenericKey tryKey;
-  int matchBits, permuteBits, permuteMax, ipermute;
-  int tryIndex;
-  int found = 0, bestIndex = -999999;
-  struct sockaddr_in bestSin, trySin;
-
-  /*
-   * This code assumes that we are looking to match
-   * a "level" in the tree.
-   */
-  assert(maxTry % bitsPerLevel == 0);
-  assert(maxTry - minTry < bitsPerLevel);
+    HintCacheNodeKey *nk;
+    HintCacheKey tryKey;
+    int matchBits, permuteBits, permuteMax, ipermute;
+    int tryIndex;
+    int found = 0, bestIndex = -999999;
+    struct sockaddr_in bestSin, trySin;
 
-  for(matchBits = maxTry; matchBits >= minTry; matchBits--){
     /*
-     * Split the address into two parts, a set of low-order bits
-     * that must match the target and a set of high-order
-     * bits that are "don't care" for which we'll try all
-     * permutations.
+     * This code assumes that we are looking to match
+     * a "level" in the tree.
      */
-    permuteBits = maxTry - matchBits;
-    permuteMax = (1 << permuteBits) - 1;
-    for(ipermute = 0; ipermute <= permuteMax; ipermute++){
-      tryKey = makeMatchKey(key, matchBits, ipermute);
-      tryIndex = fullMatchIndex(tryKey);
-      if(!List_IsEmpty(&parentListA[tryIndex])){
-	if(!found){
-	  found = 1;
-	  *amIRootRet = 0;
-	  bestSin = NodeKey_GetAddr((NodeKey *)
-				    List_First(&parentListA[tryIndex]));
-	  bestIndex = tryIndex;
-	}
-	else{
-	  trySin =  NodeKey_GetAddr((NodeKey *)
-				    List_First(&parentListA[tryIndex]));
-	  if(HCHier_compareDistanceFromMe(bestSin.sin_addr,
-					  trySin.sin_addr) > 0){
-	    bestSin = trySin;
-	    bestIndex = tryIndex;
+    assert(maxTry % bitsPerLevel == 0);
+    assert(maxTry - minTry < bitsPerLevel);
+
+    for (matchBits = maxTry; matchBits >= minTry; matchBits--) {
+	/*
+	 * Split the address into two parts, a set of low-order bits
+	 * that must match the target and a set of high-order
+	 * bits that are "don't care" for which we'll try all
+	 * permutations.
+	 */
+	permuteBits = maxTry - matchBits;
+	permuteMax = (1 << permuteBits) - 1;
+	for (ipermute = 0; ipermute <= permuteMax; ipermute++) {
+	    tryKey = makeMatchKey(key, matchBits, ipermute);
+	    tryIndex = fullMatchIndex(tryKey);
+	    if (parentListA[tryIndex].head != 0) {
+		/* parentListA[tryIndex] is not empty */
+		nk = parentListA[tryIndex].head->data;
+		if (!found) {
+		    found = 1;
+		    *amIRootRet = 0;
+		    bestSin = hintCacheNodeKeyGetAddr(nk);
+		    bestIndex = tryIndex;
+		} else {
+		    trySin = hintCacheNodeKeyGetAddr(nk);
+		    if (HCHier_compareDistanceFromMe(bestSin.sin_addr,
+			    trySin.sin_addr) > 0) {
+			bestSin = trySin;
+			bestIndex = tryIndex;
+			assert(*amIRootRet == 0);
+		    }
+		}
+	    }
+	}
+	if (found) {
 	    assert(*amIRootRet == 0);
-	  }
+	    *parentIndexRet = bestIndex;
+	    return 1;
 	}
-      }
-    }
-    if(found){
-      assert(*amIRootRet == 0);
-      *parentIndexRet = bestIndex;
-      return 1;
-    }
-  } /* for matchBits */
-  assert(!found);
-  return 0;
+    }				/* for matchBits */
+    assert(!found);
+    return 0;
 }
 
 
@@ -878,16 +874,16 @@
  *
  *------------------------------------------------------------------
  */
-static GenericKey
-makeMatchKey(const URLKey *key, int matchBits, int permuteVal)
+static HintCacheKey
+makeMatchKey(const URLKey * key, int matchBits, int permuteVal)
 {
-  GenericKey tryKey, matchMask;
+    HintCacheKey tryKey, matchMask;
 
-  matchMask = (((GenericKey)1) << matchBits) - 1;
-  tryKey = (key->key & matchMask) | (permuteVal << matchBits);
-  return tryKey;
+    matchMask = (((HintCacheKey) 1) << matchBits) - 1;
+    tryKey = (key->key & matchMask) | (permuteVal << matchBits);
+    return tryKey;
 }
-  
+
 
 /*
  *------------------------------------------------------------------
@@ -914,7 +910,7 @@
 static int
 highestMatchIndex(int match)
 {
-  return maxParentBucket + 1 + match;
+    return maxParentBucket + 1 + match;
 }
 
 /*
@@ -941,8 +937,8 @@
 static int
 normalParentIndex(int bucket)
 {
-  assert(bucket <= maxParentBucket);
-  return bucket;
+    assert(bucket <= maxParentBucket);
+    return bucket;
 }
 
 /*
@@ -968,11 +964,11 @@
 static int
 firstLevelBucketForMatch(int match)
 {
-  int level;
-  
-  assert(match <= BITS_PER_KEY);
-  level = (match/bitsPerLevel) * Plaxton_bucketsPerLevel;
-  return level;
+    int level;
+
+    assert(match <= BITS_PER_KEY);
+    level = (match / bitsPerLevel) * Plaxton_bucketsPerLevel;
+    return level;
 }
 
 
@@ -997,44 +993,41 @@
  *
  *----------------------------------------------------4.16.1998--------
  */
-int 
-plaxtonGetParentAddr (int index, struct sockaddr_in *retAddr)
+int
+plaxtonGetParentAddr(int index, struct sockaddr_in *retAddr)
 {
-  assert(initialized);
-  assert(index >= 0);
-  assert(parentListA != NULL);
-  if(index <= maxParentBucket){
-    if(!List_IsEmpty(&parentListA[index])){
-      *retAddr = ((NodeKey *)List_First(&parentListA[index]))->addr;
-      debug(HCPLAX_DEBUG, 2,
-	    "plaxtonGetParentAddr: Sending msg to parent %s\n",
-	    inet_ntoa(retAddr->sin_addr));
-      return 0;
-    }
-    else{
-      return 1;
-    }
-  }
-  else{
-    /* XXX    index = index - maxParentBucket; */
-    index = index - maxParentBucket - 1;
-    assert(index < BITS_PER_KEY);
+    assert(initialized);
     assert(index >= 0);
-    /*
-     * List always contains at least me
-     */
-    assert(!List_IsEmpty(&highestMatchA[index]));
-    if(((NodeKey *)List_First(&highestMatchA[index]))->key == myNodeKey){
-      return 1;
-    }
-    else{
-      *retAddr = ((NodeKey *)List_First(&highestMatchA[index]))->addr;
-      debug(HCPLAX_DEBUG, 2,
-	    "plaxtonGetParentAddr: Sending msg to parent %s\n",
-	    inet_ntoa(retAddr->sin_addr));
-      return 0;
+    assert(parentListA != NULL);
+    if (index <= maxParentBucket) {
+	if (!List_IsEmpty(&parentListA[index])) {
+	    *retAddr = ((HintCacheNodeKey *) List_First(&parentListA[index]))->addr;
+	    debug(HCPLAX_DEBUG, 2)
+		("plaxtonGetParentAddr: Sending msg to parent %s\n",
+		inet_ntoa(retAddr->sin_addr));
+	    return 0;
+	} else {
+	    return 1;
+	}
+    } else {
+	/* XXX    index = index - maxParentBucket; */
+	index = index - maxParentBucket - 1;
+	assert(index < BITS_PER_KEY);
+	assert(index >= 0);
+	/*
+	 * List always contains at least me
+	 */
+	assert(!List_IsEmpty(&highestMatchA[index]));
+	if (((HintCacheNodeKey *) List_First(&highestMatchA[index]))->key == myNodeKey) {
+	    return 1;
+	} else {
+	    *retAddr = ((HintCacheNodeKey *) List_First(&highestMatchA[index]))->addr;
+	    debug(HCPLAX_DEBUG, 2)
+		("plaxtonGetParentAddr: Sending msg to parent %s\n",
+		inet_ntoa(retAddr->sin_addr));
+	    return 0;
+	}
     }
-  }
 }
 
 /*
@@ -1058,13 +1051,13 @@
 void
 plaxtonAddNode(struct sockaddr_in *newNode)
 {
-  assert(initialized);
-  assert(newNode);
-#if 1  /* XXX! - disabling parent&child lists */
-  addNodeParentList(newNode);
+    assert(initialized);
+    assert(newNode);
+#if 1				/* XXX! - disabling parent&child lists */
+    addNodeParentList(newNode);
 #endif
-  addNodeHighestMatch(newNode);
-  return;
+    addNodeHighestMatch(newNode);
+    return;
 }
 
 /*
@@ -1085,14 +1078,14 @@
  *
  *-----------------------------------------------------4.16.1998------
  */
-void 
+void
 plaxtonRemoveNode(struct sockaddr_in *goneNode)
 {
-  assert(initialized);
-  assert(goneNode);
-  removeNodeParentList(goneNode);
-  removeNodeHighestMatch(goneNode);
-  return;
+    assert(initialized);
+    assert(goneNode);
+    removeNodeParentList(goneNode);
+    removeNodeHighestMatch(goneNode);
+    return;
 }
 
 /*
@@ -1114,17 +1107,17 @@
  *
  *-----------------------------------------------------4.16.1998-------
  */
-void 
+void
 plaxtonchangeDistance(struct sockaddr_in *changeDistNode)
 {
-  assert(initialized);
-  assert(changeDistNode);
-  changeDistanceParentList(changeDistNode);
-  /*
-   * Don't need to tell HighestMatch list since that one is
-   * not sorted by distance.
-   */
-  return;
+    assert(initialized);
+    assert(changeDistNode);
+    changeDistanceParentList(changeDistNode);
+    /*
+     * Don't need to tell HighestMatch list since that one is
+     * not sorted by distance.
+     */
+    return;
 }
 
 /*
@@ -1148,41 +1141,42 @@
 static void
 addNodeParentList(struct sockaddr_in *addNode)
 {
-  NodeKey *n;
-  int index;
-  NodeKey *current;
-  struct sockaddr_in s1, s2;
+    HintCacheNodeKey *n;
+    int index;
+    HintCacheNodeKey *current;
+    struct sockaddr_in s1, s2;
 
-  n = (NodeKey *)xmalloc(sizeof(NodeKey));
-  assert(n);
-  NodeKey_Init(n, addNode);
+    n = (HintCacheNodeKey *) xmalloc(sizeof(HintCacheNodeKey));
+    assert(n);
+    hintCacheNodeKeyInit(n, addNode);
 
-  index = parentListIndex(n);
+    index = parentListIndex(n);
 
 
-  if(List_IsEmpty(&parentListA[index])){
-    List_Insert((List_Links *)n, LIST_ATFRONT(&parentListA[index]));
-    return;
-  }
-  else{
-    LIST_FORALL2(&parentListA[index], NodeKey *, current){
-      if(HCHier_compareDistanceFromMe(NodeKey_GetAddr(current).sin_addr, 
-				      addNode->sin_addr) > 0){
-	List_Insert((List_Links *)n, LIST_BEFORE(current));
+    if (List_IsEmpty(&parentListA[index])) {
+	List_Insert((dlink_node *) n, LIST_ATFRONT(&parentListA[index]));
 	return;
-      }
-      /*
-       * Check invariant that list is sorted by distance from me.
-       */
-      if((List_Links *)current != LIST_ATREAR(&parentListA[index])){
-	s1 = NodeKey_GetAddr(current);
-	s2 = NodeKey_GetAddr((NodeKey *)List_Next((List_Links *)current));
-	assert( HCHier_compareDistanceFromMe(s1.sin_addr, s2.sin_addr) <= 0);
-      }
-    }
-  }
-  List_Insert((List_Links *)n, LIST_ATREAR(&parentListA[index]));
-  return;
+    } else {
+	LIST_FORALL2(&parentListA[index], HintCacheNodeKey *, current) {
+	    if (HCHier_compareDistanceFromMe(hintCacheNodeKeyGetAddr(current).sin_addr,
+		    addNode->sin_addr) > 0) {
+		List_Insert((dlink_node *) n, LIST_BEFORE(current));
+		return;
+	    }
+	    /*
+	     * Check invariant that list is sorted by distance from me.
+	     */
+	    if ((dlink_node *) current != LIST_ATREAR(&parentListA[index])) {
+		s1 = hintCacheNodeKeyGetAddr(current);
+		s2 = hintCacheNodeKeyGetAddr((HintCacheNodeKey *) List_Next((dlink_node *)
+			current));
+		assert(HCHier_compareDistanceFromMe(s1.sin_addr,
+			s2.sin_addr) <= 0);
+	    }
+	}
+    }
+    List_Insert((dlink_node *) n, LIST_ATREAR(&parentListA[index]));
+    return;
 }
 
 /*
